// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/SilhouetteMatchObject.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/silhouette_match_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `object_id`
// Member `region_of_interest_2d_id`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__msg__SilhouetteMatchObject__init(rc_reason_msgs__msg__SilhouetteMatchObject * msg)
{
  if (!msg) {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__init(&msg->object_id)) {
    rc_reason_msgs__msg__SilhouetteMatchObject__fini(msg);
    return false;
  }
  // region_of_interest_2d_id
  if (!rosidl_runtime_c__String__init(&msg->region_of_interest_2d_id)) {
    rc_reason_msgs__msg__SilhouetteMatchObject__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchObject__fini(rc_reason_msgs__msg__SilhouetteMatchObject * msg)
{
  if (!msg) {
    return;
  }
  // object_id
  rosidl_runtime_c__String__fini(&msg->object_id);
  // region_of_interest_2d_id
  rosidl_runtime_c__String__fini(&msg->region_of_interest_2d_id);
}

bool
rc_reason_msgs__msg__SilhouetteMatchObject__are_equal(const rc_reason_msgs__msg__SilhouetteMatchObject * lhs, const rc_reason_msgs__msg__SilhouetteMatchObject * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->object_id), &(rhs->object_id)))
  {
    return false;
  }
  // region_of_interest_2d_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->region_of_interest_2d_id), &(rhs->region_of_interest_2d_id)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__SilhouetteMatchObject__copy(
  const rc_reason_msgs__msg__SilhouetteMatchObject * input,
  rc_reason_msgs__msg__SilhouetteMatchObject * output)
{
  if (!input || !output) {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__copy(
      &(input->object_id), &(output->object_id)))
  {
    return false;
  }
  // region_of_interest_2d_id
  if (!rosidl_runtime_c__String__copy(
      &(input->region_of_interest_2d_id), &(output->region_of_interest_2d_id)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__SilhouetteMatchObject *
rc_reason_msgs__msg__SilhouetteMatchObject__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchObject * msg = (rc_reason_msgs__msg__SilhouetteMatchObject *)allocator.allocate(sizeof(rc_reason_msgs__msg__SilhouetteMatchObject), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__SilhouetteMatchObject));
  bool success = rc_reason_msgs__msg__SilhouetteMatchObject__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__SilhouetteMatchObject__destroy(rc_reason_msgs__msg__SilhouetteMatchObject * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__SilhouetteMatchObject__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__init(rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchObject * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__SilhouetteMatchObject *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__SilhouetteMatchObject), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__SilhouetteMatchObject__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__SilhouetteMatchObject__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__fini(rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__SilhouetteMatchObject__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__SilhouetteMatchObject__Sequence *
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * array = (rc_reason_msgs__msg__SilhouetteMatchObject__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__SilhouetteMatchObject__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__destroy(rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__are_equal(const rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * lhs, const rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__SilhouetteMatchObject__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__SilhouetteMatchObject__Sequence__copy(
  const rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * input,
  rc_reason_msgs__msg__SilhouetteMatchObject__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__SilhouetteMatchObject);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__SilhouetteMatchObject * data =
      (rc_reason_msgs__msg__SilhouetteMatchObject *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__SilhouetteMatchObject__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__SilhouetteMatchObject__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__SilhouetteMatchObject__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
