// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/DetectTags.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'tags'
#include "rc_reason_msgs/msg/detail/tag__struct.h"
// Member 'pose_frame'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/DetectTags in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectTags_Request
{
  /// Tags to detect. For pose estimation by homography, the sizes of the tags
  /// must be set.
  rc_reason_msgs__msg__Tag__Sequence tags;
  /// Optional. Pose frame for output poses (valid values are 'camera' and 'external', defaults to 'camera')
  rosidl_runtime_c__String pose_frame;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
} rc_reason_msgs__srv__DetectTags_Request;

// Struct for a sequence of rc_reason_msgs__srv__DetectTags_Request.
typedef struct rc_reason_msgs__srv__DetectTags_Request__Sequence
{
  rc_reason_msgs__srv__DetectTags_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectTags_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'tags'
#include "rc_reason_msgs/msg/detail/detected_tag__struct.h"
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/DetectTags in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectTags_Response
{
  /// List of detected tags.
  rc_reason_msgs__msg__DetectedTag__Sequence tags;
  /// Timestamp of the detection
  builtin_interfaces__msg__Time timestamp;
  /// Return value
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__DetectTags_Response;

// Struct for a sequence of rc_reason_msgs__srv__DetectTags_Response.
typedef struct rc_reason_msgs__srv__DetectTags_Response__Sequence
{
  rc_reason_msgs__srv__DetectTags_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectTags_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__STRUCT_H_
