// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/SetLoadCarrier.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'load_carrier'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetLoadCarrier_Request_
{
  using Type = SetLoadCarrier_Request_<ContainerAllocator>;

  explicit SetLoadCarrier_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : load_carrier(_init)
  {
    (void)_init;
  }

  explicit SetLoadCarrier_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : load_carrier(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _load_carrier_type =
    rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>;
  _load_carrier_type load_carrier;

  // setters for named parameter idiom
  Type & set__load_carrier(
    const rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator> & _arg)
  {
    this->load_carrier = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Request
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Request
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetLoadCarrier_Request_ & other) const
  {
    if (this->load_carrier != other.load_carrier) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetLoadCarrier_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetLoadCarrier_Request_

// alias to use template instance with default allocator
using SetLoadCarrier_Request =
  rc_reason_msgs::srv::SetLoadCarrier_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetLoadCarrier_Response_
{
  using Type = SetLoadCarrier_Response_<ContainerAllocator>;

  explicit SetLoadCarrier_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : return_code(_init)
  {
    (void)_init;
  }

  explicit SetLoadCarrier_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : return_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Response
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SetLoadCarrier_Response
    std::shared_ptr<rc_reason_msgs::srv::SetLoadCarrier_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetLoadCarrier_Response_ & other) const
  {
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetLoadCarrier_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetLoadCarrier_Response_

// alias to use template instance with default allocator
using SetLoadCarrier_Response =
  rc_reason_msgs::srv::SetLoadCarrier_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct SetLoadCarrier
{
  using Request = rc_reason_msgs::srv::SetLoadCarrier_Request;
  using Response = rc_reason_msgs::srv::SetLoadCarrier_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__STRUCT_HPP_
