// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/LoadCarrier.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'id'
#include "rosidl_runtime_c/string.h"
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__struct.h"
// Member 'rim_thickness'
#include "rc_reason_msgs/msg/detail/rectangle__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in msg/LoadCarrier in the package rc_reason_msgs.
/**
  * This represents a load carrier by its geometry and its pose
 */
typedef struct rc_reason_msgs__msg__LoadCarrier
{
  rosidl_runtime_c__String id;
  /// Required
  rc_reason_msgs__msg__Box outer_dimensions;
  /// Required
  rc_reason_msgs__msg__Box inner_dimensions;
  /// Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
  rc_reason_msgs__msg__Rectangle rim_thickness;
  /// When setting a load carrier, this is the prior if frame_id is not empty (should be 'camera' or 'external')
  /// For detected load carriers, this is the detected pose
  geometry_msgs__msg__PoseStamped pose;
  /// True if a detected load carrier is overfilled. Ignored on setting load carrier.
  bool overfilled;
} rc_reason_msgs__msg__LoadCarrier;

// Struct for a sequence of rc_reason_msgs__msg__LoadCarrier.
typedef struct rc_reason_msgs__msg__LoadCarrier__Sequence
{
  rc_reason_msgs__msg__LoadCarrier * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__LoadCarrier__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_
