// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/CalibrateBasePlane.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/calibrate_base_plane__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'plane'
#include "shape_msgs/msg/detail/plane__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const CalibrateBasePlane_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: pose_frame
  {
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << ", ";
  }

  // member: robot_pose
  {
    out << "robot_pose: ";
    to_flow_style_yaml(msg.robot_pose, out);
    out << ", ";
  }

  // member: plane_estimation_method
  {
    out << "plane_estimation_method: ";
    rosidl_generator_traits::value_to_yaml(msg.plane_estimation_method, out);
    out << ", ";
  }

  // member: stereo_plane_preference
  {
    out << "stereo_plane_preference: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_plane_preference, out);
    out << ", ";
  }

  // member: region_of_interest_2d_id
  {
    out << "region_of_interest_2d_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_2d_id, out);
    out << ", ";
  }

  // member: offset
  {
    out << "offset: ";
    rosidl_generator_traits::value_to_yaml(msg.offset, out);
    out << ", ";
  }

  // member: plane
  {
    out << "plane: ";
    to_flow_style_yaml(msg.plane, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrateBasePlane_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_pose:\n";
    to_block_style_yaml(msg.robot_pose, out, indentation + 2);
  }

  // member: plane_estimation_method
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plane_estimation_method: ";
    rosidl_generator_traits::value_to_yaml(msg.plane_estimation_method, out);
    out << "\n";
  }

  // member: stereo_plane_preference
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stereo_plane_preference: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_plane_preference, out);
    out << "\n";
  }

  // member: region_of_interest_2d_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "region_of_interest_2d_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_2d_id, out);
    out << "\n";
  }

  // member: offset
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset: ";
    rosidl_generator_traits::value_to_yaml(msg.offset, out);
    out << "\n";
  }

  // member: plane
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plane:\n";
    to_block_style_yaml(msg.plane, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrateBasePlane_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::CalibrateBasePlane_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::CalibrateBasePlane_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::CalibrateBasePlane_Request>()
{
  return "rc_reason_msgs::srv::CalibrateBasePlane_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::CalibrateBasePlane_Request>()
{
  return "rc_reason_msgs/srv/CalibrateBasePlane_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CalibrateBasePlane_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CalibrateBasePlane_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::CalibrateBasePlane_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'plane'
// already included above
// #include "shape_msgs/msg/detail/plane__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const CalibrateBasePlane_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: pose_frame
  {
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << ", ";
  }

  // member: plane
  {
    out << "plane: ";
    to_flow_style_yaml(msg.plane, out);
    out << ", ";
  }

  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrateBasePlane_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: plane
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plane:\n";
    to_block_style_yaml(msg.plane, out, indentation + 2);
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrateBasePlane_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::CalibrateBasePlane_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::CalibrateBasePlane_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::CalibrateBasePlane_Response>()
{
  return "rc_reason_msgs::srv::CalibrateBasePlane_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::CalibrateBasePlane_Response>()
{
  return "rc_reason_msgs/srv/CalibrateBasePlane_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CalibrateBasePlane_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CalibrateBasePlane_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::CalibrateBasePlane_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::CalibrateBasePlane>()
{
  return "rc_reason_msgs::srv::CalibrateBasePlane";
}

template<>
inline const char * name<rc_reason_msgs::srv::CalibrateBasePlane>()
{
  return "rc_reason_msgs/srv/CalibrateBasePlane";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CalibrateBasePlane>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::CalibrateBasePlane_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::CalibrateBasePlane_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CalibrateBasePlane>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::CalibrateBasePlane_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::CalibrateBasePlane_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::CalibrateBasePlane>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::CalibrateBasePlane_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::CalibrateBasePlane_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__TRAITS_HPP_
